.386
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                  I N C L U D E   F I L E S
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

INCLUDE \masm32\include\windows.inc
INCLUDE \masm32\include\kernel32.inc
INCLUDE \masm32\include\user32.inc

INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                         D A T A
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
.DATA?

hWnd    HWND ?

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                         C O D E
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
.CODE

szProgman        db "Progman",0
szProgramManager db "Program Manager",0
szDefView        db "SHELLDLL_DefView",0
szNullString     db 0
szListView       db "SysListView32",0
szFolderView     db "FolderView",0


;
; EntryPoint
;

EntryPoint:
  ; Desktop
  invoke  GetDesktopWindow
  test    eax, eax
  jz      EP_Exit

  ; Program manager
  invoke  FindWindowEx, eax, 0, ADDR szProgman, ADDR szProgramManager
  test    eax, eax
  jz      EP_Exit

  ; SHELLDLL_DefView
  invoke  FindWindowEx, eax, 0, ADDR szDefView, ADDR szNullString
  test    eax, eax
  jz      EP_Exit

  ; Icons ListView
  invoke  FindWindowEx, eax, 0, ADDR szListView, ADDR szFolderView
  test    eax, eax
  jz      EP_Exit
  mov     hWnd, eax

  ;-------------------------------------------------------------------------------------------------

  ; Get old style
  invoke  GetWindowLong, eax, GWL_STYLE
  and     eax, NOT LVS_TYPEMASK
  
  ; NOTE:
  ;   LVS_NOSCROLL is not compatible with LVS_LIST or LVS_REPORT
  ;   So it *must* be disabled (NAND'ed) if using any of these two styles
  ;   It should be enabled (OR'ed) if using LVS_ICON or LVS_SMALLICON

  ; Details view
  and     eax, NOT LVS_NOSCROLL
  or      eax, LVS_REPORT

  ; Default view (large icons)
  ;or      eax, LVS_ICON OR LVS_NOSCROLL
  
  invoke  SetWindowLong, hWnd, GWL_STYLE, eax

  ;-------------------------------------------------------------------------------------------------

EP_Exit:
  invoke  ExitProcess, 0


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
END EntryPoint
